﻿using System;
using System.Globalization;
using System.Windows;
using System.Windows.Data;

namespace WpfApp1
{
    [ValueConversion(typeof(Visibility), typeof(bool))]
    public class BoolToNotVisibilityConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            // Get the value as a bool, with a default value of false if not.
            bool v = (bool?)value ?? false;

            // Determine the "false" value, since it could be collapsed or hidden.
            var def = parameter as Visibility? ?? Visibility.Collapsed;

            // Return the result.
            return v == false ? Visibility.Visible : def;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var v = (Visibility?)value;

            return v != Visibility.Visible;
        }
    }
}