﻿using System;
using System.Windows;
using System.Windows.Media;

namespace WpfApp1
{
    public static class DependencyObjectExtension
    {
        public static bool TryCast<TElement>(this DependencyObject dObj, out TElement element)
            where TElement : UIElement
        {
            element = dObj as TElement;
            return element != null;
        }

        public static DependencyObject FindAncestorOfType(this DependencyObject o, Type ancestorType)
        {
            DependencyObject res = null;

            var parent = VisualTreeHelper.GetParent(o);
            if (parent != null)
            {
                if (parent.GetType().IsSubclassOf(ancestorType) || parent.GetType() == ancestorType)
                    res = parent;
                else
                    res = FindAncestorOfType(parent, ancestorType);
            }

            return res;
        }
    }
}
