﻿using JetBrains.Annotations;
using System;
using System.Diagnostics;
using System.Windows.Input;

namespace WpfApp1
{
    [PublicAPI]
    public class RelayCommand : ICommand
    {
        protected Predicate<object> pmCanExecute;
        protected Action<object> pmExecute;

        protected RelayCommand()
        {
        }

        public RelayCommand(Action<object> execute, Predicate<object> canExecute = null)
        {
            pmExecute = execute ?? throw new ArgumentNullException(nameof(execute));
            pmCanExecute = canExecute;
        }

        [DebuggerStepThrough]
        public bool CanExecute(object parameter)
        {
            return pmCanExecute?.Invoke(parameter) ?? true;
        }

        public event EventHandler CanExecuteChanged { add => CommandManager.RequerySuggested += value; remove => CommandManager.RequerySuggested -= value; }

        public void Execute(object parameter)
        {
            pmExecute(parameter);
        }
    }
}
